Package net.sf.saxon.tree.linked

## Class NodeImpl

- java.lang.Object
- - net.sf.saxon.tree.linked.NodeImpl

- All Implemented Interfaces:
    `javax.xml.transform.Source`, `javax.xml.transform.SourceLocator`, `GroundedValue`, `Item`, `MutableNodeInfo`, `NodeInfo`, `Sequence`, `Location`, `SteppingNode<NodeImpl>`, `SiblingCountingNode`, `org.xml.sax.Locator`
  Direct Known Subclasses:
    `AttributeImpl`, `CommentImpl`, `ParentNodeImpl`, `ProcInstImpl`, `TextImpl`

      public abstract class NodeImpl
      extends java.lang.Object
      implements MutableNodeInfo, SteppingNode<NodeImpl>, SiblingCountingNode, Location

  A node in the "linked" tree representing any kind of node except a namespace node. Specific node kinds are represented by concrete subclasses.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static char[]` | `NODE_LETTER` | Chararacteristic letters to identify each type of node, indexed using the node type values.

    - ### Fields inherited from interface net.sf.saxon.om.NodeInfo

      `IS_DTD_TYPE, IS_NILLED`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `NodeImpl()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addAttribute​(NodeName name, SimpleType attType, java.lang.CharSequence value, int properties, boolean inheritNamespaces)` | Add an attribute to this element node.
    `void` | `addNamespace​(NamespaceBinding nscode, boolean inheritNamespaces)` | Add a namespace binding (that is, a namespace node) to this element.
    `AtomicSequence` | `atomize()` | Get the typed value.
    `AttributeMap` | `attributes()` | Get the attributes of the node.
    `int` | `compareOrder​(NodeInfo other)` | Determine the relative position of this node and another node, in document order.
    `void` | `delete()` | Delete this node (that is, detach it from its parent)
    `boolean` | `effectiveBooleanValue()` | Get the effective boolean value of this sequence
    `boolean` | `equals​(NodeInfo other)` | Determine whether this is the same node as another node
    `void` | `generateId​(FastStringBuffer buffer)` | Get a character string that uniquely identifies this node
    `NamespaceMap` | `getAllNamespaces()` | Get all the namespace bindings that are in-scope for this element.
    `java.lang.String` | `getAttributeValue​(java.lang.String uri, java.lang.String localName)` | Find the value of a given attribute of this node.
    `java.lang.String` | `getBaseURI()` | Get the base URI for the node.
    `int` | `getColumnNumber()` | Get the column number of the node.
    `Configuration` | `getConfiguration()` | Get the configuration
    `NamespaceBinding[]` | `getDeclaredNamespaces​(NamespaceBinding[] buffer)` | Get all namespace undeclarations and undeclarations defined on this element.
    `java.lang.String` | `getDisplayName()` | Get the display name of this node.
    `int` | `getFingerprint()` | Get the fingerprint of the node.
    `NodeImpl` | `getFirstChild()` | Get first child - default implementation used for leaf nodes
    `NodeInfo` | `getLastChild()` | Get last child - default implementation used for leaf nodes
    `int` | `getLineNumber()` | Get the line number of the node within its source document entity
    `java.lang.String` | `getLocalPart()` | Get the local name of this node.
    `NamePool` | `getNamePool()` | Get the NamePool
    `NodeImpl` | `getNextInDocument​(NodeImpl anchor)` | Get the next node in document order
    `NodeImpl` | `getNextSibling()` | Get next sibling node
    `NodeName` | `getNodeName()` | Get the name of the node.
    `NodeImpl` | `getParent()` | Find the parent node of this node.
    `DocumentImpl` | `getPhysicalRoot()` | Get the physical root of the tree.
    `java.lang.String` | `getPrefix()` | Get the prefix part of the name of this node.
    `NodeImpl` | `getPreviousInDocument()` | Get the previous node in document order
    `NodeImpl` | `getPreviousSibling()` | Get the previous sibling of the node
    `protected ParentNodeImpl` | `getRawParent()` | Get the raw value of the parent pointer.
    `NodeInfo` | `getRoot()` | Get the root node
    `SchemaType` | `getSchemaType()` | Get the type annotation
    `protected long` | `getSequenceNumber()` | Get the node sequence number (in document order).
    `int` | `getSiblingPosition()` | Get the index position of this node among its siblings (starting from 0)
    `java.lang.CharSequence` | `getStringValueCS()` | Get the value of the item as a CharSequence.
    `NodeImpl` | `getSuccessorElement​(NodeImpl anchor, java.lang.String uri, java.lang.String local)` | Find the next matching element in document order; that is, the first child element with the required name if there is one; otherwise the next sibling element if there is one; otherwise the next sibling element of the parent, grandparent, etc, up to the anchor element.
    `java.lang.String` | `getSystemId()` | Get the system ID for the node.
    `TreeInfo` | `getTreeInfo()` | Get information about the tree to which this NodeInfo belongs
    `java.lang.String` | `getURI()` | Get the URI part of the name of this node.
    `boolean` | `hasChildNodes()` | Determine whether the node has any children.
    `boolean` | `hasFingerprint()` | Ask whether this NodeInfo implementation holds a fingerprint identifying the name of the node in the NamePool.
    `NodeImpl` | `head()` | To implement `Sequence`, this method returns the item itself
    `void` | `insertChildren​(NodeInfo[] source, boolean atStart, boolean inherit)` | Insert a sequence of nodes as children of this node.
    `void` | `insertSiblings​(NodeInfo[] source, boolean before, boolean inherit)` | Insert copies of a sequence of nodes as siblings of this node.
    `boolean` | `isDeleted()` | Test whether this MutableNodeInfo object represents a node that has been deleted.
    `AxisIterator` | `iterateAxis​(int axisNumber)` | Return an iterator over the nodes reached by the given axis from this node
    `AxisIterator` | `iterateAxis​(int axisNumber, java.util.function.Predicate<? super NodeInfo> nodeTest)` | Return an enumeration over the nodes reached by the given axis from this node
    `Builder` | `newBuilder()` | Get a Builder suitable for building nodes that can be attached to this document.
    `void` | `removeAttribute​(NodeInfo attribute)` | Remove an attribute from this element node
    `void` | `removeTypeAnnotation()` | Remove type information from this node (and its ancestors, recursively).
    `void` | `rename​(NodeName newNameCode, boolean inheritNamespaces)` | Rename this node
    `void` | `replace​(NodeInfo[] replacement, boolean inherit)` | Replace this node with a given sequence of nodes.
    `Location` | `saveLocation()` | Get an immutable copy of this Location object.
    `void` | `setAttributes​(AttributeMap attributes)` | Set the attribute list for this (element) node
    `protected void` | `setRawParent​(ParentNodeImpl parent)` | Set the raw parent pointer
    `protected void` | `setSiblingPosition​(int index)` | Set the index position.
    `void` | `setSystemId​(java.lang.String uri)` | Set the system ID of this node.
    `void` | `setTypeAnnotation​(SchemaType type)` | Set the type annotation on a node.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `asIterable, concatenate, containsNode, materialize`

    - ### Methods inherited from interface net.sf.saxon.om.Item

      `getLength, itemAt, iterate, reduce, subsequence`

    - ### Methods inherited from interface net.sf.saxon.om.MutableNodeInfo

      `addNamespace, removeNamespace, replaceStringValue`

    - ### Methods inherited from interface net.sf.saxon.om.NodeInfo

      `children, children, copy, equals, getGenre, getNodeKind, getPublicId, getStringValue, hashCode, isId, isIdref, isNilled, isSameNodeInfo, isStreamed, toShortString`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `makeRepeatable`

    - ### Methods inherited from interface javax.xml.transform.Source

      `isEmpty`

- - ### Field Detail

    - #### NODE_LETTER

          public static final char[] NODE_LETTER

      Chararacteristic letters to identify each type of node, indexed using the node type values. These are used as the initial letter of the result of generate-id()

  - ### Constructor Detail

    - #### NodeImpl

          public NodeImpl()

  - ### Method Detail

    - #### head

          public NodeImpl head()

      To implement `Sequence`, this method returns the item itself
      Specified by:
        `head` in interface `GroundedValue`
      Specified by:
        `head` in interface `Item`
      Specified by:
        `head` in interface `Sequence`
      Returns:
        this item

    - #### getTreeInfo

          public TreeInfo getTreeInfo()

      Get information about the tree to which this NodeInfo belongs
      Specified by:
        `getTreeInfo` in interface `NodeInfo`
      Returns:
        the TreeInfo
      Since:
        9.7

    - #### getStringValueCS

          public java.lang.CharSequence getStringValueCS()

      Get the value of the item as a CharSequence. This is in some cases more efficient than the version of the method that returns a String.
      Specified by:
        `getStringValueCS` in interface `GroundedValue`
      Specified by:
        `getStringValueCS` in interface `Item`
      Returns:
        the string value of the item
      See Also:
        `Item.getStringValue()`

    - #### getSchemaType

          public SchemaType getSchemaType()

      Get the type annotation
      Specified by:
        `getSchemaType` in interface `NodeInfo`
      Returns:
        the type annotation of the base node

    - #### getColumnNumber

          public int getColumnNumber()

      Get the column number of the node. The default implementation returns -1, meaning unknown
      Specified by:
        `getColumnNumber` in interface `Location`
      Specified by:
        `getColumnNumber` in interface `org.xml.sax.Locator`
      Specified by:
        `getColumnNumber` in interface `NodeInfo`
      Specified by:
        `getColumnNumber` in interface `javax.xml.transform.SourceLocator`
      Returns:
        the column number of the node in its original source document; or -1 if not available. The default implementation returns -1.

    - #### getSiblingPosition

          public final int getSiblingPosition()

      Get the index position of this node among its siblings (starting from 0)
      Specified by:
        `getSiblingPosition` in interface `SiblingCountingNode`
      Returns:
        0 for the first child, 1 for the second child, etc. Returns -1 for a node that has been deleted.

    - #### setSiblingPosition

          protected final void setSiblingPosition​(int index)

      Set the index position. For internal use only
      Parameters:
        `index` - the position of the node among its siblings, counting from zero.

    - #### atomize

          public AtomicSequence atomize()
                                 throws XPathException

      Get the typed value.
      Specified by:
        `atomize` in interface `Item`
      Specified by:
        `atomize` in interface `NodeInfo`
      Returns:
        the typed value. If requireSingleton is set to true, the result will always be an AtomicValue. In other cases it may be a Value representing a sequence whose items are atomic values.
      Throws:
        `XPathException` - if the node has no typed value, for example if it is an element node with element-only content
      Since:
        8.5

    - #### setSystemId

          public void setSystemId​(java.lang.String uri)

      Set the system ID of this node. This method is provided so that a NodeInfo implements the javax.xml.transform.Source interface, allowing a node to be used directly as the Source of a transformation
      Specified by:
        `setSystemId` in interface `javax.xml.transform.Source`

    - #### equals

          public boolean equals​(NodeInfo other)

      Determine whether this is the same node as another node
      Returns:
        true if this Node object and the supplied Node object represent the same node in the tree.

    - #### getNodeName

          public NodeName getNodeName()

      Get the name of the node. Returns null for an unnamed node
      Returns:
        the name of the node

    - #### hasFingerprint

          public boolean hasFingerprint()

      Ask whether this NodeInfo implementation holds a fingerprint identifying the name of the node in the NamePool. If the answer is true, then the `getFingerprint()` method must return the fingerprint of the node. If the answer is false, then the `getFingerprint()` method should throw an `UnsupportedOperationException`. In the case of unnamed nodes such as text nodes, the result can be either true (in which case getFingerprint() should return -1) or false (in which case getFingerprint may throw an exception).
      Specified by:
        `hasFingerprint` in interface `NodeInfo`
      Returns:
        true if the implementation of this node provides fingerprints.
      Since:
        9.8; previously Saxon relied on using `FingerprintedNode` as a marker interface.

    - #### getFingerprint

          public int getFingerprint()

      Get the fingerprint of the node. This is used to compare whether two nodes have equivalent names. Return -1 for a node with no name.
      Specified by:
        `getFingerprint` in interface `NodeInfo`
      Returns:
        an integer fingerprint; two nodes with the same fingerprint have the same expanded QName. For unnamed nodes (text nodes, comments, document nodes, and namespace nodes for the default namespace), returns -1.

    - #### attributes

          public AttributeMap attributes()

      Get the attributes of the node. By default there are none; this is overridden for element nodes
      Specified by:
        `attributes` in interface `NodeInfo`
      Returns:
        an empty attribute map

    - #### generateId

          public void generateId​(FastStringBuffer buffer)

      Get a character string that uniquely identifies this node
      Specified by:
        `generateId` in interface `NodeInfo`
      Parameters:
        `buffer` - a buffer which will be updated to hold a string that uniquely identifies this node, across all documents.

    - #### getSystemId

          public java.lang.String getSystemId()

      Get the system ID for the node. Default implementation for child nodes.
      Specified by:
        `getSystemId` in interface `Location`
      Specified by:
        `getSystemId` in interface `org.xml.sax.Locator`
      Specified by:
        `getSystemId` in interface `NodeInfo`
      Specified by:
        `getSystemId` in interface `javax.xml.transform.Source`
      Specified by:
        `getSystemId` in interface `javax.xml.transform.SourceLocator`
      Returns:
        the System Identifier of the entity in the source document containing the node, or null if not known or not applicable.

    - #### getBaseURI

          public java.lang.String getBaseURI()

      Get the base URI for the node. Default implementation for child nodes.
      Specified by:
        `getBaseURI` in interface `NodeInfo`
      Returns:
        the base URI of the node. This may be null if the base URI is unknown, including the case where the node has no parent.

    - #### getSequenceNumber

          protected long getSequenceNumber()

      Get the node sequence number (in document order). Sequence numbers are monotonic but not consecutive. In the current implementation, parent nodes (elements and roots) have a zero least-significant word, while namespaces, attributes, text nodes, comments, and PIs have the top word the same as their owner and the bottom half reflecting their relative position. This is the default implementation for child nodes. For nodes added by XQuery Update, the sequence number is -1L
      Returns:
        the sequence number if there is one, or -1L otherwise.

    - #### compareOrder

          public final int compareOrder​(NodeInfo other)

      Determine the relative position of this node and another node, in document order. The other node will always be in the same document.
      Specified by:
        `compareOrder` in interface `NodeInfo`
      Parameters:
        `other` - The other node, whose position is to be compared with this node
      Returns:
        -1 if this node precedes the other node, +1 if it follows the other node, or 0 if they are the same node. (In this case, isSameNode() will always return true, and the two nodes will produce the same result for generateId())

    - #### getConfiguration

          public Configuration getConfiguration()

      Get the configuration
      Specified by:
        `getConfiguration` in interface `NodeInfo`
      Returns:
        the Configuration to which the tree belongs. The default implementation invokes `getTreeInfo().getConfiguration()`.

    - #### getNamePool

          public NamePool getNamePool()

      Get the NamePool

    - #### getPrefix

          public java.lang.String getPrefix()

      Get the prefix part of the name of this node. This is the name before the ":" if any.
      Specified by:
        `getPrefix` in interface `NodeInfo`
      Returns:
        the prefix part of the name. For an unnamed node, return an empty string.

    - #### getURI

          public java.lang.String getURI()

      Get the URI part of the name of this node. This is the URI corresponding to the prefix, or the URI of the default namespace if appropriate.
      Specified by:
        `getURI` in interface `NodeInfo`
      Returns:
        The URI of the namespace of this node. For the null namespace, return an empty string. For an unnamed node, return the empty string.

    - #### getDisplayName

          public java.lang.String getDisplayName()

      Get the display name of this node. For elements and attributes this is [prefix:]localname. For unnamed nodes, it is an empty string.
      Specified by:
        `getDisplayName` in interface `NodeInfo`
      Returns:
        The display name of this node. For a node with no name, return an empty string.

    - #### getLocalPart

          public java.lang.String getLocalPart()

      Get the local name of this node.
      Specified by:
        `getLocalPart` in interface `NodeInfo`
      Returns:
        The local name of this node. For a node with no name, return "",.

    - #### getLineNumber

          public int getLineNumber()

      Get the line number of the node within its source document entity
      Specified by:
        `getLineNumber` in interface `Location`
      Specified by:
        `getLineNumber` in interface `org.xml.sax.Locator`
      Specified by:
        `getLineNumber` in interface `NodeInfo`
      Specified by:
        `getLineNumber` in interface `javax.xml.transform.SourceLocator`
      Returns:
        the line number of the node in its original source document; or -1 if not available. The default implementation returns -1.

    - #### saveLocation

          public Location saveLocation()

      Get an immutable copy of this Location object. By default Location objects may be mutable, so they should not be saved for later use. The result of this operation holds the same location information, but in an immutable form.
      Specified by:
        `saveLocation` in interface `Location`
      Returns:
        an immutable copy (which may be the original object, if it is already immutable)

    - #### getParent

          public final NodeImpl getParent()

      Find the parent node of this node.
      Specified by:
        `getParent` in interface `NodeInfo`
      Specified by:
        `getParent` in interface `SteppingNode<NodeImpl>`
      Returns:
        The Node object describing the containing element or root node.

    - #### getRawParent

          protected final ParentNodeImpl getRawParent()

      Get the raw value of the parent pointer. This will usually be the same as the parent node in the XDM model, but in the case of a parentless element it will be a pointer to the "imaginary" document node which is not properly part of the tree.
      Returns:
        either the real parent of this node, or the "imaginary" parent present in the tree implementation to provide a root object for the tree

    - #### setRawParent

          protected final void setRawParent​(ParentNodeImpl parent)

      Set the raw parent pointer
      Parameters:
        `parent` - the "raw" parent pointer: either the real parent, or a dummy parent added to ensure that the tree is properly rooted.

    - #### getPreviousSibling

          public NodeImpl getPreviousSibling()

      Get the previous sibling of the node
      Specified by:
        `getPreviousSibling` in interface `SteppingNode<NodeImpl>`
      Returns:
        The previous sibling node. Returns null if the current node is the first child of its parent.

    - #### getNextSibling

          public NodeImpl getNextSibling()

      Get next sibling node
      Specified by:
        `getNextSibling` in interface `SteppingNode<NodeImpl>`
      Returns:
        The next sibling node of the required type. Returns null if the current node is the last child of its parent.

    - #### getFirstChild

          public NodeImpl getFirstChild()

      Get first child - default implementation used for leaf nodes
      Specified by:
        `getFirstChild` in interface `SteppingNode<NodeImpl>`
      Returns:
        null

    - #### getLastChild

          public NodeInfo getLastChild()

      Get last child - default implementation used for leaf nodes
      Returns:
        null

    - #### iterateAxis

          public AxisIterator iterateAxis​(int axisNumber)

      Return an iterator over the nodes reached by the given axis from this node
      Specified by:
        `iterateAxis` in interface `NodeInfo`
      Parameters:
        `axisNumber` - The axis to be iterated over
      Returns:
        an AxisIterator that scans the nodes reached by the axis in turn.
      See Also:
        `AxisInfo`

    - #### iterateAxis

          public AxisIterator iterateAxis​(int axisNumber,
                                          java.util.function.Predicate<? super NodeInfo> nodeTest)

      Return an enumeration over the nodes reached by the given axis from this node
      Specified by:
        `iterateAxis` in interface `NodeInfo`
      Parameters:
        `axisNumber` - The axis to be iterated over
        `nodeTest` - A pattern to be matched by the returned nodes
      Returns:
        an AxisIterator that scans the nodes reached by the axis in turn.
      See Also:
        `AxisInfo`

    - #### getAttributeValue

          public java.lang.String getAttributeValue​(java.lang.String uri,
                                                    java.lang.String localName)

      Find the value of a given attribute of this node.
      This method is defined on all nodes to meet XSL requirements, but for nodes other than elements it will always return null.
      Specified by:
        `getAttributeValue` in interface `NodeInfo`
      Parameters:
        `uri` - the namespace uri of an attribute
        `localName` - the local name of an attribute
      Returns:
        the value of the attribute, if it exists, otherwise null

    - #### getRoot

          public NodeInfo getRoot()

      Get the root node
      Specified by:
        `getRoot` in interface `NodeInfo`
      Returns:
        the NodeInfo representing the logical root of the tree. For this tree implementation the root will either be a document node or an element node.

    - #### getPhysicalRoot

          public DocumentImpl getPhysicalRoot()

      Get the physical root of the tree. This may be an imaginary document node: this method should be used only when control information held at the physical root is required
      Returns:
        the document node, which may be imaginary. In the case of a node that has been detached from the tree by means of a delete() operation, this method returns null.

    - #### getNextInDocument

          public NodeImpl getNextInDocument​(NodeImpl anchor)

      Get the next node in document order
      Parameters:
        `anchor` - the scan stops when it reaches a node that is not a descendant of the specified anchor node
      Returns:
        the next node in the document, or null if there is no such node

    - #### getSuccessorElement

          public NodeImpl getSuccessorElement​(NodeImpl anchor,
                                              java.lang.String uri,
                                              java.lang.String local)

      Description copied from interface: `SteppingNode`
      Find the next matching element in document order; that is, the first child element with the required name if there is one; otherwise the next sibling element if there is one; otherwise the next sibling element of the parent, grandparent, etc, up to the anchor element.
      Specified by:
        `getSuccessorElement` in interface `SteppingNode<NodeImpl>`
      Parameters:
        `anchor` - the root of the tree within which navigation is confined
        `uri` - the required namespace URI, or null if any namespace is acceptable
        `local` - the required local name, or null if any local name is acceptable
      Returns:
        the next element after this one in document order, with the given URI and local name if specified, or null if this is the last node in the document, or the last node within the subtree being navigated

    - #### getPreviousInDocument

          public NodeImpl getPreviousInDocument()

      Get the previous node in document order
      Returns:
        the previous node in the document, or null if there is no such node

    - #### getDeclaredNamespaces

          public NamespaceBinding[] getDeclaredNamespaces​(NamespaceBinding[] buffer)

      Get all namespace undeclarations and undeclarations defined on this element.
      Specified by:
        `getDeclaredNamespaces` in interface `NodeInfo`
      Parameters:
        `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
      Returns:
        An array of integers representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. Otherwise, the returned array is a sequence of namespace codes, whose meaning may be interpreted by reference to the name pool. The top half word of each namespace code represents the prefix, the bottom half represents the URI. If the bottom half is zero, then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to -1.

        For a node other than an element, the method returns null.

    - #### getAllNamespaces

          public NamespaceMap getAllNamespaces()

      Get all the namespace bindings that are in-scope for this element.

      For an element return all the prefix-to-uri bindings that are in scope. This may include a binding to the default namespace (represented by a prefix of ""). The map does NOT include the implicit binding of the XML namespace. It will never include "undeclarations" - that is, the namespace URI will never be empty; the effect of an undeclaration is to remove a binding from the in-scope namespaces, not to add anything.

      For a node other than an element, returns null.

      Specified by:
        `getAllNamespaces` in interface `NodeInfo`
      Returns:
        the in-scope namespaces for an element, or null for any other kind of node.

    - #### hasChildNodes

          public boolean hasChildNodes()

      Determine whether the node has any children.
      Specified by:
        `hasChildNodes` in interface `NodeInfo`
      Returns:
        `true` if the node has any children, `false` if the node has no children.

    - #### setTypeAnnotation

          public void setTypeAnnotation​(SchemaType type)

      Set the type annotation on a node. This must only be called when the caller has verified (by validation) that the node is a valid instance of the specified type. The call is ignored if the node is not an element or attribute node.
      Specified by:
        `setTypeAnnotation` in interface `MutableNodeInfo`
      Parameters:
        `type` - the type annotation (possibly including high bits set to indicate the isID, isIDREF, and isNilled properties)

    - #### delete

          public void delete()

      Delete this node (that is, detach it from its parent)
      Specified by:
        `delete` in interface `MutableNodeInfo`

    - #### isDeleted

          public boolean isDeleted()

      Test whether this MutableNodeInfo object represents a node that has been deleted. Generally, such a node is unusable, and any attempt to use it will result in an exception being thrown
      Specified by:
        `isDeleted` in interface `MutableNodeInfo`
      Returns:
        true if this node has been deleted

    - #### setAttributes

          public void setAttributes​(AttributeMap attributes)

      Set the attribute list for this (element) node
      Specified by:
        `setAttributes` in interface `MutableNodeInfo`
      Parameters:
        `attributes` - the new attribute list
      Throws:
        `java.lang.UnsupportedOperationException` - if this is not an element node

    - #### removeAttribute

          public void removeAttribute​(NodeInfo attribute)

      Remove an attribute from this element node

      If this node is not an element, or if the specified node is not an attribute of this element, this method takes no action.

      The attribute object itself becomes unusable; any attempt to use this attribute object, or any other object representing the same node, is likely to result in an exception.

      Specified by:
        `removeAttribute` in interface `MutableNodeInfo`
      Parameters:
        `attribute` - the attribute node to be removed

    - #### addAttribute

          public void addAttribute​(NodeName name,
                                   SimpleType attType,
                                   java.lang.CharSequence value,
                                   int properties,
                                   boolean inheritNamespaces)

      Add an attribute to this element node.

      If this node is not an element, or if the supplied node is not an attribute, the method takes no action. If the element already has an attribute with this name, the method throws an exception.

      This method does not perform any namespace fixup. It is the caller's responsibility to ensure that any namespace prefix used in the name of the attribute (or in its value if it has a namespace-sensitive type) is declared on this element.

      Specified by:
        `addAttribute` in interface `MutableNodeInfo`
      Parameters:
        `name` - the name of the new attribute
        `attType` - the type annotation of the new attribute
        `value` - the string value of the new attribute
        `properties` - properties including IS_ID and IS_IDREF properties
        `inheritNamespaces` -
      Throws:
        `java.lang.IllegalStateException` - if the element already has an attribute with the given name.

    - #### rename

          public void rename​(NodeName newNameCode,
                             boolean inheritNamespaces)

      Rename this node
      Specified by:
        `rename` in interface `MutableNodeInfo`
      Parameters:
        `newNameCode` - the NamePool code of the new name
        `inheritNamespaces` -

    - #### addNamespace

          public void addNamespace​(NamespaceBinding nscode,
                                   boolean inheritNamespaces)

      Description copied from interface: `MutableNodeInfo`
      Add a namespace binding (that is, a namespace node) to this element. This call has no effect if applied to a node other than an element.
      Specified by:
        `addNamespace` in interface `MutableNodeInfo`
      Parameters:
        `nscode` - The namespace code representing the (prefix, uri) pair of the namespace binding to be added. If the target element already has a namespace binding with this (prefix, uri) pair, the call has no effect. If the target element currently has a namespace binding with this prefix and a different URI, an exception is raised. The new namespace binding will also be in scope for the subtree rooted at this node (that is, the namespace is implicitly inherited)

    - #### replace

          public void replace​(NodeInfo[] replacement,
                              boolean inherit)

      Replace this node with a given sequence of nodes. This node is effectively deleted, and the replacement nodes are attached to the parent of this node in its place.

      The supplied nodes will become children of this node's parent. Adjacent text nodes will be merged, and zero-length text nodes removed. The supplied nodes may be modified in situ, for example to change their parent property and to add namespace bindings, or they may be copied, at the discretion of the implementation.

      Specified by:
        `replace` in interface `MutableNodeInfo`
      Parameters:
        `replacement` - the replacement nodes. If this node is an attribute, the replacements must also be attributes; if this node is not an attribute, the replacements must not be attributes. source the nodes to be inserted. The implementation determines what implementation classes of node it will accept; this implementation will accept attribute, text, comment, and processing instruction nodes belonging to any implementation, but elements must be instances of `ElementImpl`. The supplied nodes will be modified in situ, for example to change their parent property and to add namespace bindings, if they are instances of `ElementImpl`; otherwise they will be copied. If the nodes are copied, then on return the supplied source array will contain the copy rather than the original.
        `inherit` - true if the replacement nodes are to inherit the namespaces of their new parent; false if such namespaces are to be undeclared
      Throws:
        `java.lang.IllegalArgumentException` - if any of the replacement nodes is of the wrong kind. When replacing a child node, the replacement nodes must all be elements, text, comment, or PI nodes; when replacing an attribute, the replacement nodes must all be attributes.
        `java.lang.IllegalStateException` - if this node is deleted or if it has no parent node. or if two replacement attributes have the same name.

    - #### insertChildren

          public void insertChildren​(NodeInfo[] source,
                                     boolean atStart,
                                     boolean inherit)

      Insert a sequence of nodes as children of this node.

      This method takes no action unless the target node is a document node or element node. It also takes no action in respect of any supplied nodes that are not elements, text nodes, comments, or processing instructions.

      The supplied nodes will form the new children. Adjacent text nodes will be merged, and zero-length text nodes removed. The supplied nodes may be modified in situ, for example to change their parent property and to add namespace bindings, or they may be copied, at the discretion of the implementation.

      Specified by:
        `insertChildren` in interface `MutableNodeInfo`
      Parameters:
        `source` - the nodes to be inserted. The implementation determines what implementation classes of node it will accept; all implementations must accept nodes constructed using the Builder supplied by the `newBuilder()` method on this object. The supplied nodes may be modified in situ, for example to change their parent property and to add namespace bindings, but this depends on the implementation. The argument array may be modified as a result of the call.
        `atStart` - true if the new nodes are to be inserted before existing children; false if they are to be inserted after existing children
        `inherit` - true if the inserted nodes are to inherit the namespaces of their new parent; false if such namespaces are to be undeclared
      Throws:
        `java.lang.IllegalArgumentException` - if the supplied nodes use a node implementation that this implementation does not accept.

    - #### insertSiblings

          public void insertSiblings​(NodeInfo[] source,
                                     boolean before,
                                     boolean inherit)

      Insert copies of a sequence of nodes as siblings of this node.

      This method takes no action unless the target node is an element, text node, comment, or processing instruction, and one that has a parent node. It also takes no action in respect of any supplied nodes that are not elements, text nodes, comments, or processing instructions.

      The supplied nodes must use the same data model implementation as the tree into which they will be inserted.

      Specified by:
        `insertSiblings` in interface `MutableNodeInfo`
      Parameters:
        `source` - the nodes to be inserted
        `before` - true if the new nodes are to be inserted before the target node; false if they are
        `inherit` - true if the inserted nodes are to inherit the namespaces of their new parent; false if such namespaces are to be undeclared

    - #### removeTypeAnnotation

          public void removeTypeAnnotation()

      Remove type information from this node (and its ancestors, recursively). This method implements the upd:removeType() primitive defined in the XQuery Update specification
      Specified by:
        `removeTypeAnnotation` in interface `MutableNodeInfo`

    - #### newBuilder

          public Builder newBuilder()

      Get a Builder suitable for building nodes that can be attached to this document.
      Specified by:
        `newBuilder` in interface `MutableNodeInfo`
      Returns:
        a new Builder that constructs nodes using the same object model implementation as this one, suitable for attachment to this tree

    - #### effectiveBooleanValue

          public boolean effectiveBooleanValue()
                                        throws XPathException

      Get the effective boolean value of this sequence
      Specified by:
        `effectiveBooleanValue` in interface `GroundedValue`
      Returns:
        the effective boolean value
      Throws:
        `XPathException` - if the sequence has no effective boolean value (for example a sequence of two integers)